import { mapObjIndexed, has, replace, curry, prop, path, dissoc, merge } from 'ramda'
import listPath from './listPath'

const derefSchema = (schema, initial) => {
  if (initial === undefined) {
    initial = schema
  }

  return mapObjIndexed((v, k) => {
    if (typeof v === 'object' && null !== v && false == v instanceof Array) {
      if (has('$ref', v)) {
        let ref = replace('#/definitions', '', prop('$ref', v))
        let refPath = listPath(ref)
        let refVal = path(refPath, initial.definitions)
        v = dissoc('$ref', v)
        v = merge(v, refVal)
      }
      return derefSchema(v, initial)
    } else {
      return v
    }
  }, schema)

}

export default derefSchema
